# LoraRb methods
module LoraRb
  # It contains generic methods
  module Base

    # Substitute tags with data into url
    def merge_tags_to_url(url, tags={}, options={})
      url = url.dup
      puts "merge_tags_to_url: #{url}" if options[:debug] == :full
      tags.each do |tag, value|
        puts " replace {#{tag}} with #{value}" if options[:debug] == :full
        url.gsub!("{#{tag}}", value.to_s)
      end
      puts "merge_tags_to_url: completed #{url}" if options[:debug] == :full
      url
    end

    def lora_encode(payload)
      Base64.encode64(payload.scan(/.{2}/).map { |b| b.to_i(16).chr }.join)
    end

    def lora_decode(payload)
      Base64.decode64(payload).unpack("H*").first
    end
  end

  private

  def puts(message)
    Kernel.puts "[#{self.class.name}##{__method__}] #{Time.now} #{message}"
  end
end